// Generated by CoffeeScript 2.5.1
(function() {
  var NUM_OF_LINE, STATEMENT_CREATE_TABLE, STATEMENT_DROP_TABLE, STATEMENT_INSERT2, TABLE_NAME, assert, cluster, columnValueString, createCargo, crypto, debuglog, folderOfCargoFile, fs, getClickhouseClient, isInited, main, mkdirp, os, path, prepareBulkCachFile, rimraf, rimrafSync;

  ({createCargo, isInited, getClickhouseClient} = require("../"));

  debuglog = require("debug")("chcargo:cluster-test:05");

  assert = require("assert");

  crypto = require('crypto');

  fs = require("fs");

  os = require("os");

  path = require("path");

  cluster = require('cluster');

  ({rimraf, rimrafSync} = require('rimraf'));

  ({mkdirp} = require('mkdirp'));

  TABLE_NAME = "default.unittest05";

  STATEMENT_CREATE_TABLE = `CREATE TABLE ${TABLE_NAME}
(
  \`time\` DateTime ,
  \`step\`  UInt32,
  \`pos_id\` String DEFAULT ''
)
ENGINE = Memory()`;

  STATEMENT_CREATE_TABLE = STATEMENT_CREATE_TABLE.replace(/\n|\r/g, ' ');

  columnValueString = Date.now().toString(36);

  STATEMENT_DROP_TABLE = `DROP TABLE IF EXISTS ${TABLE_NAME}`;

  NUM_OF_LINE = 12;

  STATEMENT_INSERT2 = `insert into ${TABLE_NAME}`;

  folderOfCargoFile = path.join(process.cwd(), "cargo_files");

  rimrafSync(folderOfCargoFile);

  mkdirp.sync(folderOfCargoFile);

  prepareBulkCachFile = function(tableName, label) {
    var arr, content, i, j, ref, theFilepath;
    theFilepath = path.join(process.cwd(), "cargo_files", `cargo_${tableName}.${Date.now().toString(36)}_unittest.nocluster.uncommitted`);
    debuglog("[prepare] theFilepath:", theFilepath);
    content = "";
    for (i = j = 0, ref = NUM_OF_LINE; (0 <= ref ? j < ref : j > ref); i = 0 <= ref ? ++j : --j) {
      arr = [Math.round(Date.now() / 1000), i, label || "cluster-cargo"];
      content += JSON.stringify(arr) + "\n";
    }
    content = content.substr(0, content.length - 1);
    fs.writeFileSync(theFilepath, content);
  };

  main = async function() {
    var StartCountWithinProcess, clickHouseClient, crashProc, proc, theCargo;
    if (cluster.isMaster) {
      debuglog("[isMaster] rebuild data table");
      clickHouseClient = getClickhouseClient();
      await clickHouseClient.exec({
        query: STATEMENT_DROP_TABLE
      });
      await clickHouseClient.exec({
        query: STATEMENT_CREATE_TABLE
      });
      prepareBulkCachFile(TABLE_NAME, "~batchAAA");
      prepareBulkCachFile(TABLE_NAME, "~batchBBB");
      proc = function() {
        var i, j;
// spawn worker
        for (i = j = 0; j < 8; i = ++j) {
          cluster.fork();
        }
      };
      proc();
      setInterval(proc, 20000);
    } else {
      //statment = not(cluster.worker.id % 2) && STATEMENT_INSERT || STATEMENT_INSERT2
      debuglog(`[isWorker ${cluster.worker.id}]`);
      //theCargo = createCargo(statment)
      theCargo = createCargo(TABLE_NAME);
      StartCountWithinProcess = 0;
      proc = function() {
        var i, j, mark, ref;
        mark = `worker@${cluster.worker.id}:${StartCountWithinProcess++}`;
        debuglog("proc insert: ", mark);
        for (i = j = 0, ref = NUM_OF_LINE; (0 <= ref ? j < ref : j > ref); i = 0 <= ref ? ++j : --j) {
          theCargo.push(new Date(), i, mark);
        }
      };
      setInterval(proc, 2000);
      crashProc = function() {
        nonExistingFunc();
      };
      return setTimeout(crashProc, 10000 + Math.random() * 60000 >>> 0);
    }
  };

  main();

}).call(this);
